English ▼
Skip to page content Skip to main navigation
e.g. "templates" or "datastore"

# The Python Runtime Environment

App Engine applications can be implemented using the Python programming language. The App Engine Python runtime environment includes a specialized version of the Python interpreter, the standard Python library, libraries and APIs for App Engine, and a standard interface to the web server layer.

For more information about Python, see the Python website and the Python documentation.

This chapter has the following sections:

- Overview
- Runtime Environment
- Python 2.7
  - What's New in Python 2.7
  - Using Python 2.7
- Backends
  - Overview
  - Reference
    - Backends API Functions
    - Backends API Exceptions
    - Runtime API
- Storing Data
  - Datastore Overview
  - Entities
  - Queries
  - Transactions
  - Data Modeling
  - GQL Reference
  - Choosing a Datastore
  - Using the High Replication Datastore
  - Metadata Queries
  - Statistics
  - Async API
  - Reference
    - Types and Property Classes
    - GQL Reference
    - Model
    - Expando
    - PolyModel
    - Property
    - Query
    - GqlQuery
    - Metadata Entities
    - Key
    - Functions
    - Exceptions
  - NDB
    - NDB Overview
    - Entities and Keys
    - Properties
    - Writing Property Subclasses
    - Queries
    - Transactions
    - Administration
    - Asynchronous Operation
    - Caching
    - Reference
      - Context
      - Future
      - Key
      - Model
      - Query
      - PolyModel
      - Metadata
      - functions
  - Google Cloud Storage
    - Overview
    - Functions
    - Exceptions

- Data Processing
  - Overview
  - Hello World
  - Reference
    - Mapreduce Pipeline
    - Standard Input Readers and Output Writers
- Services
  - App Identity
    - Overview
    - Reference
      - Functions
      - Exceptions
  - Blobstore
    - Overview
    - Reference
      - `BlobInfo`
      - `BlobKey`
      - `BlobReader`
      - Blobstore RPC
      - Functions
      - Exceptions
  - Capabilities
    - Overview
    - Reference
      - CapabilitySet
      - Exceptions
  - Conversion
    - Overview
    - Reference
      - Conversion Class
      - Property Classes
      - Functions
      - Exceptions
  - Channel
    - Overview
    - Reference
      - Functions
      - Exceptions
      - Client Javascript Reference
  - Images
    - Overview
    - Installing PIL
    - Using the Images API
    - Reference
      - Image
      - Functions
      - Exceptions
  - LogService
    - Reference
      - AppLog
      - RequestLog
      - Functions
      - Exceptions
  - Mail
    - Overview
    - Sending Mail
    - Receiving Mail
    - Attachments
    - Headers
    - Reference
      - EmailMessage
      - Message Fields
      - Functions
      - Exceptions
  - Memcache
    - Overview
    - Using Memcache
    - Reference
      - Client
      - Functions
  - Multitenancy
    - Overview
    - Multitenancy with Namespaces
    - Other Uses for Namespaces
    - Reference
      - Functions
      - Exceptions
  - OAuth
    - Overview
    - Reference
      - Functions
      - Exceptions
  - Prospective Search
    - Overview
    - Reference
      - Functions
      - Exceptions
  - Task Queues
    - Overview
    - Using Push Queues
    - Using Pull QueuesNew!
    - Reference
      - Task Class
      - TaskRetryOptions Class
      - Queue Class
      - REST (Experimental)
      - Functions
      - Exceptions
  - URL Fetch
    - Overview
    - Reference
      - The fetch Function
      - Asynchronous Requests
      - Response Objects
      - Exceptions
  - Users
    - Overview
    - User Objects
    - Login URLs
    - Admin Users
    - Reference
      - User
      - Functions
      - Exceptions
  - XMPP
    - Overview
    - Reference
      - Functions
      - Message
      - Exceptions
- Configuration
  - App Config
  - Backends Config
  - Index Config
  - Scheduled Tasks
  - Task Queue Config
  - DoS Protection Config
- Tools
  - Development Server
  - Uploading and Managing an App
  - Uploading and Downloading Data
  - ProtoRPC
    - Overview
    - Definition Module
    - Descriptor Module
      - DescriptorLibrary Functions
      - Functions
    - Messages Module
      - Enum
      - EnumField
      - Field
      - Message Field Classes
      - Message
      - MessageField
      - Variant
      - Functions
      - Exceptions
    - Remote Service Library
      - Overview
      - HttpRequestState Class
      - RequestState Class
      - RpcStatus Class
      - Service Class
      - Functions
      - Exceptions
    - Transport Library
      - HttpTransport Class
      - Transport Class
    - WebApp Service Handlers
      - Overview
      - WebApp Service Handlers
  - webapp Framework
    - Overview
    - Running the Application
    - Request Handlers
    - Request Data
    - Building the Response
    - Redirects, Headers and Status Codes
    - Blobstore Handlers
    - Reference
      - Request
      - Response
      - RequestHandler
      - WSGIApplication
      - Utility Functions
  - Local Unit Testing
  - Appstats
  - Included Libraries (Python 2.5)
  - Included Libraries(Python 2.7)
  - Python Module Configuration
- How-To
  - Google Data Services
  - Handling Scheduled Maintenance Periods